/*
 * Author: Hiroyuki Chishiro
 * License: 2-Clause BSD
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#define SERVER_PATH "/tmp/unix_sock.server"
#define SEND_DATA "Hello World"

int main(void)
{
  int client_sock, n;
  struct sockaddr_un addr;

  memset(&addr, 0, sizeof(struct sockaddr_un));

  if ((client_sock = socket(AF_UNIX, SOCK_DGRAM, 0)) < 0) {
    perror("socket");
    return 1;
  }

  addr.sun_family = AF_UNIX;
  strcpy(addr.sun_path, SERVER_PATH);

  if ((n = sendto(client_sock, SEND_DATA, sizeof(SEND_DATA), 0,
                  (struct sockaddr *) &addr, sizeof(addr))) < 0) {
    perror("sendto");
    goto end_socket;
  }

  if (n == sizeof(SEND_DATA)) {
    printf("Sending data is successful.\n");
  } else {
    printf("Sending data is not successful.\n");
  }

end_socket:

  if (close(client_sock) < 0) {
    perror("close");
    return 2;
  }

  return 0;
}
