/*
 * Author: Hiroyuki Chishiro
 * License: 2-Clause BSD
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#define SOCK_PATH "/tmp/unix_sock.server"
#define BUFSIZE 1024

int main(void)
{
  int server_sock;
  socklen_t len;
  struct sockaddr_un server_addr, peer_addr;
  char buf[BUFSIZE];

  memset(buf, 0, BUFSIZE);

  if ((server_sock = socket(AF_UNIX, SOCK_DGRAM, 0)) < 0) {
    perror("socket");
    return 1;
  }

  memset(&server_addr, 0, sizeof(struct sockaddr_un));
  server_addr.sun_family = AF_UNIX;
  strcpy(server_addr.sun_path, SOCK_PATH);
  len = sizeof(server_addr);
  unlink(SOCK_PATH);

  if (bind(server_sock, (struct sockaddr *) &server_addr, len) < 0) {
    perror("bind");
    goto end_server_socket;
  }

  if (recvfrom(server_sock, buf, BUFSIZE, 0,
               (struct sockaddr *) &peer_addr, &len) < 0) {
    perror("recvfrom");
    goto end_server_socket;
  }

  printf("%s\n", buf);

end_server_socket:

  if (close(server_sock) < 0) {
    perror("close");
    return 2;
  }

  return 0;
}
